;lowbatt
;-----
;by Levi Lansing
;--puzzlesome@hotmail.com
;--http://www.crosswinds.net/levisti86/

;by the way, this was made in Assembly Studio 86 v3.0 so if you have v3.1, you
;may have to change the header files...

#include "asm86.h"
#include "ti86asm.inc"

_cursoron	.EQU	4994h
_cursoroff	.EQU	498Ch
_jforcecmdnochar	.EQU	409Ch
_user_int_ram EQU $d2fd
_user_on_int_ram EQU $d48f


;this is the code that will replace the label pushR when the prgm is compiled
#define pushR  in a,(5) \ push af \ ld a,$0d \ out (5),a \ nop \ nop \ nop
;this is the code that will replace the label popR when the prgm is compiled
#define popR   pop af \ out (5),a


.org _asm_exec_ram
  bit 3,(iy+$23)	;is the user interrupt on?
  jp nz,undo		;go turn it it off if it is


   ld hl,int					;hl point to the begining of the program
   ld de,_user_on_int_ram+1		;de pionts to where the program is to be loaded
   ld bc,int_end-int		;bc is the length of the program to be sent
   ldir							;copies it
   
   ld a,(_user_on_int_ram+1)		;this sets up checksum byte
   ld hl,_user_on_int_ram+($28*1)	;we need to add the 1st bite with one
   add a,(hl)						;every 40 bytes and store it in the...
   ld hl,_user_on_int_ram+($28*2)
   add a,(hl)
   ld hl,_user_on_int_ram+($28*3)
   add a,(hl)
   ld hl,_user_on_int_ram+($28*4)
   add a,(hl)
   ld hl,_user_on_int_ram+($28*5)
   add a,(hl)
   ld (_user_on_int_ram),a			;first byte of the interrupt area

  set 3,(iy+$23)		;turn on the user on interrupt
  call _clrScrn			;clear the screen
  call _homeup			;move the cursor to the top left
  ld hl,on				;point hl to the on text
  call _puts			;display it
  ret					;return from this program

undo:
  res 3,(iy+$23)		;turn off the user on interrupt
  call _clrScrn			;clear the screen
  call _homeup			;move the cursor to the top left
  ld hl,off				;point hl to the off text
  call _puts			;display it
  ret					;return from this program

on:
  .db "ON",0
off:
  .db "OFF",0


int:		;this is the begining of the program that will be copied into the user int mem
  push af			;when you run an interrupt, you can't change ANY registers
  push bc			;so you must push all the regesters you use
  push de
  push hl			;and pop (restore) them at the end
  pushR
  call _clrScrn		;clear the screen
  call _homeup		;move the cursor to the top left
  ld hl,TEXT
  call _puts		;display the message
  call _homeup		;move the cursor to the top left
  ei				enable the interupts so the cursor will blink and for the halts
  set 3,(iy+$08)	;turn on the auto power down
  ld a,$0b			;turn on screen (note: this only works if the OS shut
  out ($03),a		;off the calc)
  set curAble,(iy+curflags)		;turn on the cursor

keyloop:
  halt				;halts the CPU until the next interrupt occurs
  halt				;(saves batteries by using less power)
  halt
  halt
  ld a,%10000000	;don't mask out any keys
  out (1),a			;out to the key port
  in a,(1)			;read from the keyport
  cp $FF			;check if no keys were pressed
  jr z,keyloop		;if none were, go to keyloop

done:
  di				;disable the interrupts (the way it was before)
  call _clrScrn		;clear the screen
  call _homeup		;move the cursor to the top left
  popR		;restore our variables in the opposite order we pushed them
  pop hl
  pop de
  pop bc
  pop af
  ret			;return from the interrupt

TEXT equ $-int+_user_on_int_ram+1
	.db "                     "
	.db "Your batteries       "
	.db "are low.             "
	.db "                     "
	.db "Recommend            "
	.db "change of            "
	.db "batteries.           ",0
int_end:

.end		;All DONE!

